hdu 4035 Maze(比较经典的树形期望DP)

Maze

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65768/65768 K (Java/Others)

Total Submission(s): 1677    Accepted Submission(s): 638

Special Judge

Problem Description

When wake up, lxhgww find himself in a huge maze.

The maze consisted by N rooms and tunnels connecting these rooms. Each pair of rooms is connected by one and only one path. Initially, lxhgww is in room 1. Each room has a dangerous trap. When lxhgww step into a room, he has a possibility to be killed and restart
from room 1. Every room also has a hidden exit. Each time lxhgww comes to a room, he has chance to find the exit and escape from this maze.

Unfortunately, lxhgww has no idea about the structure of the whole maze. Therefore, he just chooses a tunnel randomly each time. When he is in a room, he has the same possibility to choose any tunnel connecting that room (including the tunnel he used to come
to that room).

What is the expect number of tunnels he go through before he find the exit?

Input

First line is an integer T (T ≤ 30), the number of test cases.

At the beginning of each case is an integer N (2 ≤ N ≤ 10000), indicates the number of rooms in this case.

Then N-1 pairs of integers X, Y (1 ≤ X, Y ≤ N, X ≠ Y) are given, indicate there is a tunnel between room X and room Y.

Finally, N pairs of integers Ki and Ei (0 ≤ Ki, Ei ≤ 100, Ki + Ei ≤ 100, K1 = E1 = 0) are given, indicate the percent of the possibility of been killed and exit in the ith room.

Output

For each test case, output one line “Case k: ”. k is the case id, then the expect number of tunnels lxhgww go through before he exit. The answer with relative error less than 0.0001 will get accepted. If it is not possible to escape
from the maze, output “impossible”.

Sample Input

3
3
1 2
1 3
0 0
100 0
0 100
3
1 2
2 3
0 0
100 0
0 100
6
1 2
2 3
1 4
4 5
4 6
0 0
20 30
40 30
50 50
70 10
20 60

Sample Output

Case 1: 2.000000
Case 2: impossible
Case 3: 2.895522

Source

The 36th ACM/ICPC Asia Regional Chengdu Site —— Online
Contest

Recommend

lcy   |   We have carefully selected several similar problems for you:  4037 4036 4033 4038 4039

题意:

一些房间构成一个树形的迷宫。你开始在以后房间。你每个房间你有ki的概率被杀掉。ei的概率逃出迷宫。如果既没被杀掉又没逃出去。你就会随机选一条能走的边走,最后问你走出这个迷宫需要走的边数的期望。

思路:

对于期望DP。很容易想到状态E[i]表示目前在i这个点。逃出迷宫需要走的边数的期望。然后也可以写出状态转移方程

E[i]=ki*E[1]+0*ei+(1-ei-ki)*Σ(E[j]+1)/eds[i].

j为i所连的点。eds[i]为i的边数。但是发现这个方程完全就不可解。因为方程有环。但是数据量太大高斯消元的话时间复杂明显太高。所以最后还是没做出来。然后就只有看题解咯。还是做题太少啊。这题被我忽略了很重要的一点那就是这是一颗树而不是一张图。而我的方程完全没体现它是树的特点。

如果按照树来写的话,方程应该是这样的。

j为i的儿子。fa为i的父亲。

通过观察。可以设E[i]=A[i]*E[1]+B[i]*E[fa]+C[i]。

然后

然后就上代码了:

#include<algorithm>
#include<iostream>
#include<string.h>
#include<stdio.h>
#include<math.h>
using namespace std;
const int INF=0x3f3f3f3f;
const int maxn=10010;
const double eps=1e-10;//开始-6wa了。精度要高点才行。
typedef long long ll;
struct node
{
    int v;
    node *next;
} ed[maxn<<1],*head[maxn];
int cnt,eds[maxn];
double A[maxn],B[maxn],C[maxn],ki[maxn],ei[maxn];
void adde(int u,int v)
{
    ed[cnt].v=v;
    ed[cnt].next=head[u];
    head[u]=&ed[cnt++];
}
void dfs(int fa,int u)
{
    double sa,sb,sc,mi;
    sa=sb=sc=0;
    for(node *p=head[u];p!=NULL;p=p->next)
    {
        if(p->v==fa)
            continue;
        dfs(u,p->v);
        sa+=A[p->v];
        sb+=B[p->v];
        sc+=C[p->v];
    }
    mi=(1-ki[u]-ei[u])/eds[u];
    A[u]=(ki[u]+mi*sa)/(1-mi*sb);
    B[u]=mi/(1-mi*sb);
    C[u]=(1+mi*sc-ki[u]-ei[u])/(1-mi*sb);
}
int main()
{
    int t,cas=1,n,i,u,v;

    scanf("%d",&t);
    while(t--)
    {
        scanf("%d",&n);
        cnt=0;
        memset(head,0,sizeof head);
        memset(eds,0,sizeof eds);
        for(i=1;i<n;i++)
        {
            scanf("%d%d",&u,&v);
            eds[u]++,eds[v]++;
            adde(u,v);
            adde(v,u);
        }
        for(i=1;i<=n;i++)
        {
            scanf("%lf%lf",&ki[i],&ei[i]);
            ki[i]/=100,ei[i]/=100;
        }
        dfs(-1,1);
        printf("Case %d: ",cas++);
        if(fabs(1-A[1])<eps)
            printf("impossible\n");
        else
            printf("%f\n",C[1]/(1-A[1]));
    }
    return 0;
}
时间: 2024-08-03 05:04:37

hdu 4035 Maze(比较经典的树形期望DP)的相关文章

BZOJ 2878 [Noi2012]迷失游乐园 树形期望DP+基环树

题意:链接 方法:树形期望DP+基环树 解析: 首先先看前50%的数据 是一棵树 那么我们可以搞树形DP 然后设几个正常的数组 sum[i]代表i走i的子节点的期望的和. down[i]代表从底下走到i的期望. size[i]代表i的儿子个数 up[i]代表从i往上走的期望 然后就可以推式子了 显而易见地可以推出来up的式子 然后有一些奇怪的关于根节点的特判,注意一下就OK了. 然后后50% 我们发现它是一个基环树? 那么首先可以乱搞出来环上的点,然后记录一下这个环上的点的连接方式,求一下相邻两

HDU 4035 Maze(树形概率DP)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4035 题意:一棵树,从结点1出发,在每个结点 i 都有3种可能:(1)回到结点1 , 概率 Ki:(2)结束,概率 Ei:(3)随机走一条边.(ki+ei+随机走=1) 求到结束需要走的边数的期望. 假设E[i]为点i到结束走边数的期望,则有 (以下m为点的度数) E[i]=ki*E[1]+(1-ei-ki)/m*(E[fa[i]]+1)若i为叶子节点. =ki*E(1)+(1-ki-ei)*E(f

hdu 4035 Maze(期望)

http://acm.hdu.edu.cn/showproblem.php?pid=4035 是一道很好的题目.题意是有一个迷宫,这里有n个房间,每一对房间有且只有一条隧道,一共有n-1条隧道.起初他在1号房间.他若当前在房间i,接下来有三种路径可以走:ki的概率被杀掉直接回到1号房间:ei的概率从该房间逃走,否则它有均等的概率通过隧道走到和i号房间相连的房间.问它从1号房间逃出去要走的隧道数目的期望. 设dp[i]表示在i号房间走出去要通过的隧道的期望,n-1条边将房间连成一颗无根树,对于叶子

【期望DP】 HDU 4035 Maze

通道 题意:一颗树对于在点i有3种情况:1:被杀死回到点1 --- 概率为ki,2:找到出口退出----慨率为ei,3:和该点相连有m条边,随机走一条,求从点1开始到退出的平均需要走的边数 思路: 设 E[i]表示在结点i处,要走出迷宫所要走的边数的期望.E[1]即为所求. 叶子结点: E[i] = ki*E[1] + ei*0 + (1-ki-ei)*(E[father[i]] + 1); = ki*E[1] + (1-ki-ei)*E[father[i]] + (1-ki-ei); 非叶子结

HDU 4035 Maze 概率dp+树形dp

题解:点击打开链接 #include <cstdio> #include <iostream> #include <cstring> #include <queue> #include <algorithm> #include <map> #include <cmath> using namespace std; const double eps = 1e-9; const int N = 10010; vector<

HDU 4035 Maze 概率dp 难度:2

http://acm.hdu.edu.cn/showproblem.php?pid=4035 求步数期望,设E[i]为在编号为i的节点时还需要走的步数,father为dfs树中该节点的父节点,son为dfs树种该节点的子节点的集合,kl[i]为被杀掉的概率,ex[i]为逃出的概率 mv[i]=(1-kl[i]-ex[i])/(1+len(son)) 则明显 E[i]=(E[father]+1)*mv[i]+sigma((E[son]+1)*mv[i])+E[1]*K[i] 未知量是E[i],E[

hdu 4035 Maze (概率DP)

Maze Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65768/65768 K (Java/Others) Total Submission(s): 1713    Accepted Submission(s): 659 Special Judge Problem Description When wake up, lxhgww find himself in a huge maze. The maze consisted b

HDU 4035 Maze 概率DP 好题

Maze Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65768/65768 K (Java/Others)Total Submission(s): 2012    Accepted Submission(s): 802Special Judge Problem Description When wake up, lxhgww find himself in a huge maze. The maze consisted by

HDU 4035 - Maze

1 /* 2 ID:esxgx1 3 LANG:C++ 4 PROG:hdu4035 5 */ 6 #include <cstdio> 7 #include <cstring> 8 #include <iostream> 9 #include <algorithm> 10 using namespace std; 11 12 template<int maxn, int maxe> 13 class graph { 14 int fw[maxe]